#import <Cocoa/Cocoa.h>
#include <tr1/unordered_map>
#if !__has_feature(objc_arc)
#	error This example requires ARC
#endif

namespace {
template <typename X>
struct object_equal
{
	bool operator()(const X s1, const X s2) const
	{
		return (s1==s2) || [(id)s1 isEqual:(id)s2];
	}
};

template <typename X>
struct object_hash
{
	size_t operator()(const X s1) const
	{
		return (size_t)[(id)s1 hash];
	}
};
}


int main(int argc, char **argv)
{
	std::tr1::unordered_map<id, __weak id, object_hash<id>, object_equal<id> > map;
	@autoreleasepool {
		NSString *str = [[NSString alloc] initWithUTF8String: argv[0]];
		map[@"arg0"] = str;
		NSLog(@"%@", map[@"arg0"]);
		str = nil;
	}
	NSLog(@"%@", map[@"arg0"]);
}
