#import <Foundation/Foundation.h>

@interface MessageSend : NSObject {
	/** Receiver of the message. */
	id target;
	/** The message selector. */
	NSString * selector;
	/** Array of AST nodes which evaluate to the message arguments. */
	NSMutableArray * arguments;
	/** Types for the method */
	const char *type;
}
@end

@implementation MessageSend 
- (id)initWithSelectorName: (NSString*)aSel
                 arguments: (NSArray*)args
{
	if (nil == (self = [super init]))
		{ return nil; }
	selector = [aSel copy];
	arguments = [args mutableCopy];
	return self;
}
- (id)initWithSelectorName:(NSString*)aSel
{
	return 
		[self initWithSelectorName: aSel
		                 arguments: nil];
}
- (id)init
{
	return [self initWithSelectorName: nil];
}
- (void)dealloc
{
	[selector release];
	[target release];
	[arguments release];
	[super dealloc];
}
@end
