#import <Foundation/Foundation.h>

@interface Listener : NSObject @end
@implementation Listener
- (void)notify: (NSNotification*)note
{
	NSLog(@"Received %@", note);
}
- (void)registerListener
{
	NSNotificationCenter *nc =
		[NSNotificationCenter defaultCenter];
	[nc addObserver: self
		   selector: @selector(notify:)
			   name: @"Example"
			 object: nil];
}
- (void)dealloc
{
	NSNotificationCenter *nc =
		[NSNotificationCenter defaultCenter];
	[nc removeObserver: self];
	[super dealloc];
}
@end


int main(void)
{
	[NSAutoreleasePool new];
	Listener *l = [Listener new];
	[l registerListener];
	NSNotificationCenter *nc =
		[NSNotificationCenter defaultCenter];
	[nc postNotificationName: @"Example"
	                  object: @"sender"
  	                userInfo: nil];
	[l release];
	// No listeners now exist for this one:
	[nc postNotificationName: @"Example"
	                  object: @"sender"
  	                userInfo: nil];
	[[Listener new] registerListener];
	NSNotificationQueue *nq =
		[NSNotificationQueue defaultQueue];
	NSNotification *note = [NSNotification 
		notificationWithName: @"Example"
		              object: @"sender"];
	[nq enqueueNotification: note
	           postingStyle: NSPostWhenIdle];
	[[NSRunLoop currentRunLoop] run];
	return 0;
}
