#import <Cocoa/Cocoa.h>
#import <Foundation/NSRegularExpression.h>
#import <Foundation/NSTextCheckingResult.h>

int main(void)
{
	[NSAutoreleasePool new];
	NSRegularExpression *regex = [NSRegularExpression
		regularExpressionWithPattern: @"abcd*"
		                     options: 0
		                       error: NULL];
	NSMutableString *str = [@"abcddd fish, wibble abcd, abc, foo" mutableCopy];
	NSRange all = NSMakeRange(0, [str length]);
	[regex enumerateMatchesInString: str
	                        options: 0
	                          range: all 
	                     usingBlock:
		^(NSTextCheckingResult *result, NSMatchingFlags flags, BOOL *stop)
		{
			NSLog(@"Matched range: %@", NSStringFromRange([result range]));
		}];

	NSLog(@"Copy with replacement: %@",
		[regex stringByReplacingMatchesInString: str
		                                options: 0
		                                  range: all 
		                           withTemplate: @"foo"]);

	[regex replaceMatchesInString: str
	                      options: 0
	                        range: NSMakeRange(0, [str length])
	                 withTemplate: @"f"];
	NSLog(@"In-place replacement: %@", str);
	return 0;
}

