#import <Foundation/Foundation.h>

@interface Singleton : NSObject
@end
@implementation Singleton
static Singleton *sharedInstance;
+ (void)initialize
{
	if ([Singleton class] == self)
	{	
		sharedInstance = [self new];
	}
}
+ (Singleton*)sharedInstance
{
	return sharedInstance;
}
+ (id)allocWithZone: (NSZone*)aZone
{
	if (sharedInstance && 
	    [Singleton class] == self)
	{
		[NSException raise: NSGenericException
		            format: @"May not create more than one instance of singleton."];
	}
	return [super allocWithZone: aZone];
}
@end
